VERSION 5.00
Begin VB.Form BLICK 
   AutoRedraw      =   -1  'True
   Caption         =   "BLICK - Maxent grammar-based phonotactic probability calculator"
   ClientHeight    =   8025
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   10905
   Icon            =   "ConstraintBasedPPCal.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   8025
   ScaleWidth      =   10905
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdPostPhonemeLabels 
      Caption         =   "Repost trans- cription key"
      Height          =   2775
      Left            =   10080
      TabIndex        =   7
      Top             =   2160
      Width           =   735
   End
   Begin VB.CommandButton cmdCalculateList 
      Caption         =   "Calculate scores for all words in this list"
      Enabled         =   0   'False
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   5520
      TabIndex        =   4
      Top             =   1560
      Width           =   5295
   End
   Begin VB.TextBox txtInputFileName 
      Alignment       =   2  'Center
      Height          =   495
      Left            =   5520
      TabIndex        =   3
      Text            =   "JuszcykEtAl.txt"
      Top             =   960
      Width           =   5295
   End
   Begin VB.CommandButton cmdEnd 
      Caption         =   "Ex&it"
      Height          =   2775
      Left            =   10080
      TabIndex        =   2
      Top             =   5040
      Width           =   735
   End
   Begin VB.CommandButton cmdCalculateWordMaxent 
      Caption         =   "Calculate score for this word"
      Enabled         =   0   'False
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   1560
      Width           =   5295
   End
   Begin VB.TextBox txtInputWord 
      Alignment       =   2  'Center
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Text            =   "B N IH1 K"
      Top             =   960
      Width           =   5295
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      Caption         =   "File containing a list of words"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   5400
      TabIndex        =   9
      Top             =   600
      Width           =   5415
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Single word  "
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   600
      TabIndex        =   8
      Top             =   600
      Width           =   4455
   End
   Begin VB.Label lblAnnouncements 
      Alignment       =   2  'Center
      Caption         =   "Loading up the grammar; please wait..."
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   360
      TabIndex        =   6
      Top             =   240
      Width           =   10455
   End
   Begin VB.Label lblPhonemeInventory 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   5880
      Left            =   240
      TabIndex        =   5
      Top             =   2160
      Width           =   9840
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuHowToOpenAFile 
         Caption         =   "&How to open a file"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuView 
      Caption         =   "&View"
      Begin VB.Menu mnuExpand 
         Caption         =   "Expand interface to full screen"
      End
      Begin VB.Menu mnuNormalSize 
         Caption         =   "Normal size interface"
      End
   End
   Begin VB.Menu mnuGrammars 
      Caption         =   "&Grammars"
      Begin VB.Menu mnuGrammarDefault 
         Caption         =   "Use &default grammar (Hayes, with stress constraints)"
         Checked         =   -1  'True
      End
      Begin VB.Menu mnuGrammarNoStress 
         Caption         =   "Use Hayes's grammar with no &stress constraints"
      End
      Begin VB.Menu mnuGrammarHayesWhite 
         Caption         =   "Use grammar from Hayes and &White (2013)"
      End
      Begin VB.Menu mnuGrammarCustomGrammar 
         Caption         =   "Use whatever grammar you have placed in the file &CustomGrammar.txt"
      End
   End
   Begin VB.Menu mnuUtilities 
      Caption         =   "&Utilities"
      Begin VB.Menu mnuCountNeighborsOneForm 
         Caption         =   "Count lexical neighbors for the form in left side text box"
      End
      Begin VB.Menu mnuCountNeighborsList 
         Caption         =   "Count lexical neighbors for all forms on list in right text box"
      End
      Begin VB.Menu mnuVitevitchSingleForm 
         Caption         =   "Calculate Vitevitch PPC score for the form in left side text box"
      End
      Begin VB.Menu mnuVitevichList 
         Caption         =   "Calculate Vitevitch PPC score for all forms on list in right text box"
      End
      Begin VB.Menu mnuTableau 
         Caption         =   "Include a &tableau (count violations for all words/constraints)"
      End
      Begin VB.Menu mnuViolatorList 
         Caption         =   "Include a list of words in the input file that &violate each constraint"
      End
   End
End
Attribute VB_Name = "BLICK"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

'Constraint-based phonotactic probability calculator, applying to user-input novel forms a grammar in the format of Hayes/Wilson (LI 2008).

    'Bruce Hayes, Department of Linguistics, UCLA
    'Prepared Summer 2012
    
    'Auxiliary items are included as well:
        'The system of Michael Vitevitch's Phonotactic Probability Calculator
        'Neighbor-counting.
    
    Option Explicit
    
    'Module level variables.
    
        Const mVersionNumber = "1.0"
    
    'Segments
        Public mNumberOfSegments As Long
        'The segment list is project-level and sits in Module1.
    
    'Natural classes
        Dim mNumberOfNaturalClasses As Long
        Dim mNaturalClassLabels() As String             'Text:  sequences of feature matrices.  Used only to report to the user.
        Dim mNaturalClassMembershipLists() As String    'Text:  lists of sounds comprising natural classes.  Used only to report to the user.
        Dim mNaturalClasses() As Boolean                'In this array, the value True occurs if the natural class of the column includes the segment of the row.
    
    'Variables for the maxent grammar.
        Dim mCurrentGrammar As String                   'The file name of the grammar being used.
        Dim mNumberOfConstraints As Long
        Dim mConstraintNames() As String                'The "names" are the sequences of featural expressions.
        Dim mConstraintsExpressedAsLists() As String    'The content of constraints expressed as sequences of lists of segments.
        Dim mTotalViolations() As Long                  'The total number of times the constraint is violated.
        Dim mConstraints() As Long                      'The content expressed rather abstractly, to facilitate fast lookup.  See below on format.
        Dim mTiers() As String                          'Some constraints apply on a "tier"; i.e. a subset of all of the segments.
        Dim mTiersActive As Boolean                     'Use the tiers only if the grammar has non-default tiers.
        Dim mMatrixCount() As Long
        Dim mWeights() As Single
        Dim mMaxentScore
        
    'Variables for the tableau etc. (maxent only).
        Dim mTableau() As Long
        Dim mListOfViolatingWords() As String
    
    'Report results to user, saving crucial findings obtained in the search.
        Public mReportResultsString As String
        Dim mReportResultsString2 As String     'More:  listing the constraints as segment sequences so they can be diagnosed.
    

'==============================================================================================
'===============================SETTING UP PROGRAM OPERATION===================================
'==============================================================================================

Sub Form_Load()

    'This runs when the program starts.
    
        'Install what ought to be a constant but VB6 won't let you.
            Let gLineBreak = Chr(10) + Chr(13)
            Let gDoubleLineBreak = Chr(10) + Chr(13) + Chr(10) + Chr(13)
            
        'Label the form with the version number.
            Let Me.Caption = "BLICK " + mVersionNumber + "- Maxent grammar-based phonotactic probability calculator"
        
        
        'The default grammar file should be specified
            Let mCurrentGrammar = "DefaultGrammar.txt"
        
        'Preliminary tasks:
            Call PostLastInputFileRead
            Call cmdPostPhonemeLabels_Click
            Call ReadTheSegments
            Call ReadTheNaturalClasses
            Call ReadTheGrammar
            Call Vitevitch.ReadVitevitchFiles
            Call Syllabify.ReadSyllabificationFiles
        
        'The system is now ready, so enable the buttons.
            Let cmdCalculateWordMaxent.Enabled = True
            Let cmdCalculateList.Enabled = True
            Let lblAnnouncements.Caption = "Ready; click on the button of your choice."

End Sub

Sub PostLastInputFileRead()
    'Open a little file with the filename of the last input file read.
    'If any error occurs, pick in.txt instead.
        On Error GoTo ErrorPoint
        Dim MyFileName As String
        Open App.Path + "/LastInputFileRead.txt" For Input As #1
        Line Input #1, MyFileName
        Let txtInputFileName.Text = Trim(MyFileName)
        DoEvents
        Close #1
        Exit Sub
ErrorPoint:
        Let txtInputFileName.Text = "in.txt"
        DoEvents
End Sub

Sub cmdPostPhonemeLabels_Click()
    'Post the phoneme labels, which are stored in a text file, on the program interface.
        Dim MyLine As String
        Let lblPhonemeInventory.Caption = ""
        Open App.Path + "/FilesNeededForOperation/ListOfSegmentsWithExamples.txt" For Input As #1
            Do While Not EOF(1)
                Line Input #1, MyLine
                Let lblPhonemeInventory.Caption = lblPhonemeInventory.Caption + MyLine + gLineBreak
            Loop
        Close #1
        DoEvents
End Sub

Sub ReadTheSegments()

    'It is good to have an independent list of segments, since you can use them to flag errors in the input files.
        Dim MyLine As String
        Open App.Path + "/FilesNeededForOperation/ListOfSegments.txt" For Input As #1
            Do While Not EOF(1)
                Line Input #1, MyLine
                Let mNumberOfSegments = mNumberOfSegments + 1
                ReDim Preserve gSegments(mNumberOfSegments)
                Let gSegments(mNumberOfSegments) = Trim(MyLine)
            Loop
        Close #1

End Sub

Sub ReadTheNaturalClasses()

    'The natural classes come from a file that is output by Colin Wilson's software (written for Hayes and Wilson 2008
    '   and publically available).  A copy of this file is placed in the FilesNeededForOperation folder.
    '   The classes are computed from a feature chart, fed into Wilson's program.
    
    Dim MyLine As String, MySegment As String, MySegmentIndex As Long
    Dim OKCheck As Boolean
    Dim SegmentIndex As Long
    
    'Initialize the arrays, in case the user wants to change grammars.
        Let mNumberOfNaturalClasses = 0
        ReDim mNaturalClassLabels(0)
        ReDim mNaturalClassMembershipLists(0)
        ReDim mNaturalClasses(mNumberOfSegments, 0)
        
    Open App.Path + "/Grammars/NaturalClassesFor" + mCurrentGrammar For Input As #1
        Do While Not EOF(1)
            'Grab a line with one natural class in it.
                Line Input #1, MyLine
            'Remove the caption that Colin Wilson prefixes to each class:
                Let MyLine = s.CustomResidue(MyLine, ": ")
            'Augment the count and make room in the array:
                Let mNumberOfNaturalClasses = mNumberOfNaturalClasses + 1
                ReDim Preserve mNaturalClassLabels(mNumberOfNaturalClasses)
                ReDim Preserve mNaturalClassMembershipLists(mNumberOfNaturalClasses)
            'Grab the labels:
                Let mNaturalClassLabels(mNumberOfNaturalClasses) = s.Chomp(MyLine)
                Let MyLine = s.Residue(MyLine)
                Let mNaturalClassMembershipLists(mNumberOfNaturalClasses) = s.Chomp(MyLine)
            'The class labels with more than one feature have an extra comma at the end, which must be trimmed off:
                If Right(mNaturalClassLabels(mNumberOfNaturalClasses), 1) = "," Then
                    Let mNaturalClassLabels(mNumberOfNaturalClasses) = Left(mNaturalClassLabels(mNumberOfNaturalClasses), Len(mNaturalClassLabels(mNumberOfNaturalClasses)) - 1)
                End If
            'Now find the members of this class and record them as "TRUE" entries in the natural class array.
                'Make room for them:
                    ReDim Preserve mNaturalClasses(mNumberOfSegments, mNumberOfNaturalClasses)
                'Go through this line, seeking segments:
                    Do
                        If Trim(MyLine) = "" Or Trim(MyLine) = "," Then Exit Do
                        'You must make sure everything in the list is a segment.
                            Let MySegment = s.CustomChomp(MyLine, ",")
                            Let MySegmentIndex = FindSegmentIndex(MySegment)
                            If MySegmentIndex <> -1 Then
                                Let mNaturalClasses(MySegmentIndex, mNumberOfNaturalClasses) = True
                            Else
                                MsgBox "Cannot find the segment " + MySegment + " in the list of segments file."
                                End
                            End If
                        Let MyLine = s.CustomResidue(MyLine, ",")
                    Loop        'Collect all the segments in the natural class.
        Loop                    'Go through all the natural classes in the file.
    Close #1
    
    Exit Sub
    
    'Debug
        Open App.Path + "/DebugTheNaturalClasses.txt" For Output As #2
            Print #2, Chr(9);
            For SegmentIndex = 1 To mNumberOfSegments
                Print #2, Chr(9); gSegments(SegmentIndex);
            Next SegmentIndex
            Print #2,
            Dim i As Long
            For i = 1 To mNumberOfNaturalClasses
                Print #2, " " + mNaturalClassLabels(i);
                Print #2, Chr(9) + mNaturalClassMembershipLists(i);
                For SegmentIndex = 1 To mNumberOfSegments
                    If mNaturalClasses(SegmentIndex, i) = True Then
                        Print #2, Chr(9); "1";
                    Else
                        Print #2, Chr(9); "";
                    End If
                Next SegmentIndex
                Print #2,
            Next i
        Close #2

End Sub

Sub ReadTheGrammar()

    Dim MyLine As String, MyString As String, MyNaturalClassDesignation As String, MyTier As String
    Dim NaturalClassIndex As Long, ConstraintIndex As Long
    
    'Initialize, in case this is not the first run.
        Let mNumberOfConstraints = 0
        ReDim mConstraintNames(0)
        ReDim mConstraintsExpressedAsLists(0)
        ReDim mListOfViolatingWords(0)
        ReDim mTotalViolations(0)
        ReDim mTiers(0)
        ReDim mWeights(0)
        ReDim mMatrixCount(0)
        ReDim mConstraints(4, 0)
    
    'Open the particular grammar chosen here.  This could be customized later.
        Open App.Path + "/Grammars/" + mCurrentGrammar For Input As #1
            'Debug:
                'Open "MissingNaturalClasses.txt" For Output As #3
            'Digest the grammar file one line at a time.
                Do While Not EOF(1)
                    Line Input #1, MyLine
                    'Augment the number of constraints.
                        Let mNumberOfConstraints = mNumberOfConstraints + 1
                    'Make room for the constraint name and remember it.
                        ReDim Preserve mConstraintNames(mNumberOfConstraints)
                        ReDim Preserve mConstraintsExpressedAsLists(mNumberOfConstraints)
                        ReDim Preserve mTotalViolations(mNumberOfConstraints)
                        ReDim Preserve mListOfViolatingWords(mNumberOfConstraints)
                        Let mConstraintNames(mNumberOfConstraints) = s.Chomp(MyLine)
                    'Make a start on the constraint names expressed as segment lists.
                        Let mConstraintsExpressedAsLists(mNumberOfConstraints) = "*"
                    'Look up the tier of a constraint.
                        Let MyLine = s.Residue(MyLine)
                        Let MyTier = s.Chomp(MyLine)
                        If MyTier <> "default" Then Let mTiersActive = True
                        ReDim Preserve mTiers(mNumberOfConstraints)
                        Let mTiers(mNumberOfConstraints) = Mid(MyTier, 7, Len(MyTier) - 7)
                    'Make room for the weight and remember it.
                        ReDim Preserve mWeights(mNumberOfConstraints)
                        Let mWeights(mNumberOfConstraints) = Val(s.Residue(MyLine))
                    'Make room for the designation of its matrix count and remember it.
                        ReDim Preserve mMatrixCount(mNumberOfConstraints)
                        ReDim Preserve mConstraints(4, mNumberOfConstraints)
                    'Parse the constraint name and extract the natural classes it contains.
                        'Form a convenient buffer for succinctness.
                            Let MyString = mConstraintNames(mNumberOfConstraints)
                        'Peel off the * that conventionally begins each constraint.
                            Let MyString = Mid(MyString, 2)
                        'Loop through, looking for the featurally-described natural classes.
                            Do
                                'Exit if you have parsed all the natural class designations.
                                    If Trim(MyString) = "" Then Exit Do
                                'Peel off a leading [; brackets are not part of our official natural class formulae.
                                    If Left(MyString, 1) = "[" Then
                                        Let MyString = Mid(MyString, 2)
                                    End If
                                'Augment the number of matrices.
                                    Let mMatrixCount(mNumberOfConstraints) = mMatrixCount(mNumberOfConstraints) + 1
                                'Grab a natural class designation
                                    Let MyNaturalClassDesignation = s.CustomChomp(MyString, "]")
                                    'Find it in the list.
                                        For NaturalClassIndex = 1 To mNumberOfNaturalClasses
                                            If MyNaturalClassDesignation = mNaturalClassLabels(NaturalClassIndex) Then
                                                'You have a match; enter the index of this class.
                                                    Let mConstraints(mMatrixCount(mNumberOfConstraints), mNumberOfConstraints) = NaturalClassIndex
                                                    'Also, augment the translated version of the constraint that lists the members of the natural classes.
                                                        Let mConstraintsExpressedAsLists(mNumberOfConstraints) = _
                                                            mConstraintsExpressedAsLists(mNumberOfConstraints) + "[" + _
                                                            mNaturalClassMembershipLists(NaturalClassIndex) + "]"
                                                'No need to search further; there is at most one match.
                                                    GoTo ExitPoint
                                            End If
                                        Next NaturalClassIndex
                                    'If you've gotten here, you have a problem:  a natural class description in the grammar that is not in the class list.
                                        MsgBox "Warning: the natural class using the grammar labeled " + MyNaturalClassDesignation + " has no listing in the file of natural classes."
                                        Let mConstraints(mMatrixCount(mNumberOfConstraints), mNumberOfConstraints) = -1
                                        'Print #3, "Novel of size 1: " + MyNaturalClassDesignation
ExitPoint:
                                'Remove the natural class designation that you just parsed.
                                    Let MyString = s.CustomResidue(MyString, "]")
                            Loop        'Loop through this constraint description.
                Loop                'Loop through all constraint descriptions.
        Close #1
    'Close #3
    
    Exit Sub
    
    'Debug.
        Dim i As Long
        Open App.Path + "/DebugTheGrammar.txt" For Output As #2
            For ConstraintIndex = 1 To mNumberOfConstraints
                Print #2, mConstraintNames(ConstraintIndex); Chr(9);
                Print #2, mConstraintsExpressedAsLists(ConstraintIndex); Chr(9);
                Print #2, mTiers(ConstraintIndex); Chr(9);
                Print #2, mWeights(ConstraintIndex);
                Print #2, Chr(9); mMatrixCount(ConstraintIndex);
                For i = 1 To 3
                    If mConstraints(i, ConstraintIndex) = 0 Then
                        Print #2, Chr(9);
                    Else
                        Print #2, Chr(9); mConstraints(i, ConstraintIndex);
                    End If
                Next i
                Print #2,
            Next ConstraintIndex
        Close #2
        'End

End Sub


Sub RememberInputFileName()

    'Open a little file with the filename of the last file read and record any changes.
        On Error GoTo ErrorPoint
        
        Dim MyFileName As String
        
        Open App.Path + "/LastInputFileRead.txt" For Output As #2
        Print #2, Trim(txtInputFileName.Text)
        Close #2
        Exit Sub
ErrorPoint:
        Exit Sub

End Sub

'==============================================================================================
'==========================EVALUATION OF FORMS WITH MAXENT GRAMMAR=============================
'==============================================================================================

Private Sub cmdCalculateWordMaxent_Click()

    'Using the maxent grammar, deal with just one word at a time, input by the user on the interface.
        Dim MyWord As String, MySavedWord As String, MyScore As Single
        
    'Remember the user's choice of input file.
        Call RememberInputFileName
    
    'Make sure that changes in the interface get recorded.
        DoEvents
        
    'Grab the word and clean it up; remembering the original version.
        Let MyWord = txtInputWord.Text
        Let MyWord = TrimCoda(MyWord, True)
        Let MySavedWord = MyWord
        
    'Run it past the error checker, syllabify it, announce the result, then compute the phonotactic score.
        If ErrorCheck(MyWord, True) = "AllCharactersOK" Then
            Let MyWord = Syllabify.Syllabified(MyWord)
            Let lblAnnouncements.Caption = MySavedWord + " when syllabified is " + MyWord
            Let MyScore = MaxentScore(MyWord)
            If MyScore = 0 Then
                Let lblPhonemeInventory = "The penalty score for this word is zero; no constraints are violated."
            Else
                Let lblPhonemeInventory = "The penalty score for this word is " + Trim(Str(MyScore)) + ", based on the violations given below." + gLineBreak + _
                    Replace(mReportResultsString, gSeparator, gLineBreak) + gDoubleLineBreak + _
                    "The constraints just given are rendered as segment lists below:" + gLineBreak + _
                    Replace(mReportResultsString2, gSeparator, gLineBreak)
            End If
        End If

End Sub
Sub cmdCalculateList_Click()
    'Using the maxent grammar, deal with an entire list of words.
        Call CalculateList("HayesWilson")
End Sub

Sub CalculateList(Algorithm As String)

    'Handle all the forms given in an input list. Algorithm can be either maxent or the Vitevitchian PPC, or can be counting neighbors.
        
        On Error GoTo ErrorPoint
        
        Dim MyLine As String, MyWord As String, MySavedWord As String, MyComment As String
        Dim MyErrorCheck As String
        Dim MyScoreString As String
        Dim Counter As Long
        Dim GrammarLabel As String
        Dim ConstraintIndex As Long
        
    'Remember the user's choice of input file.
        Call RememberInputFileName
        
    'In case this is not the initial run, refresh the phonetic symbol part of the interface.  Else user will be told that they are done when
    '   they are not.
    
        Call cmdPostPhonemeLabels_Click
    
        Open App.Path + "/Input/" + txtInputFileName.Text For Input As #1
            
            'Select a grammar label.
                Select Case mCurrentGrammar
                    Case "DefaultGrammar.txt"
                        Let GrammarLabel = ""
                    Case "NoStressGrammar.txt"
                        Let GrammarLabel = "NoStressGrammar"
                    Case "HayesWhiteGrammar.txt"
                        Let GrammarLabel = "HayesWhiteGrammar"
                    Case "Grammar.txt"
                        Let GrammarLabel = "CustomGrammar"
                    Case Else
                End Select
                    
            'Open the appropriate output file and print a header.
                Select Case Algorithm
                    Case "HayesWilson"
                        Open App.Path + "/Output/" + GrammarLabel + "BLICKOutputFor" + MakeUpper(txtInputFileName.Text) For Output As #2
                        Print #2, "Word"; Chr(9); "Length"; Chr(9); "Score"; Chr(9); "Constraints violated with weights"; Chr(9); "Constraints expressed as lists"; Chr(9); "Comments (copied from input file)"
                        'Here, also a tableau.
                            If mnuTableau.Checked Then
                                'Open the output file for a tableau.
                                    Open App.Path + "/Output/" + GrammarLabel + "TableauFor" + MakeUpper(txtInputFileName.Text) For Output As #3
                                'Print the multiline header:
                                    'Invariant:
                                        Print #3, "Word"; Chr(9); "Length"; Chr(9); "Score";
                                    'Constraint names:
                                        For ConstraintIndex = 1 To mNumberOfConstraints
                                            Print #3, Chr(9); mConstraintNames(ConstraintIndex);
                                        Next ConstraintIndex
                                        Print #3,
                                    'Constraints expressed as lists:
                                        Print #3, Chr(9); Chr(9);
                                        For ConstraintIndex = 1 To mNumberOfConstraints
                                            Print #3, Chr(9); mConstraintsExpressedAsLists(ConstraintIndex);
                                        Next ConstraintIndex
                                        Print #3,
                                    'Weights:
                                        Print #3, Chr(9); Chr(9);
                                        For ConstraintIndex = 1 To mNumberOfConstraints
                                            Print #3, Chr(9); Trim(Str(mWeights(ConstraintIndex)));
                                        Next ConstraintIndex
                                        Print #3,
                            End If
                    Case "Vitevitch"
                        Open App.Path + "/Output/VitevitchPPCOutputFor" + MakeUpper(txtInputFileName.Text) For Output As #2
                        Print #2, "Word"; Chr(9); "Length"; Chr(9); "Phoneme score"; Chr(9); "Basis of score"; Chr(9); "Biphone score"; Chr(9); "Basis of score"; Chr(9); "Comments (copied from input file)"
                    Case "Neighbors"
                        Open App.Path + "/Output/NeighborhoodsFor" + MakeUpper(txtInputFileName.Text) For Output As #2
                        Print #2, "Word"; Chr(9); "Length"; Chr(9); "Number of neighbors"; Chr(9); "List of neighbors"; Chr(9); "Comments (copied from input file)"
                End Select
            
            'Go through the input file one line at a time.
BlankLineRestartPoint:
                Do While Not EOF(1)
                    Line Input #1, MyLine
                    'Ignore blank lines.
                        If Trim(MyLine) = "" Then GoTo BlankLineRestartPoint
                    'Report progress
                        Let Counter = Counter + 1
                        If Int(Counter / 100) = Counter / 100 Then
                            Let lblAnnouncements.Caption = "Working on the list; completed " + Trim(Str(Counter)) + " words."
                            DoEvents
                        End If
                    'If necessary, dimension (and thus initialize) the array for constraint violations
                        If mnuTableau.Checked Then ReDim mTableau(mNumberOfConstraints)
                    'Process the input file line.
                        Let MyWord = Trim(s.Chomp(MyLine))
                        Let MyComment = s.Residue(MyLine)
                        Let MySavedWord = MyWord
                        Let MyWord = TrimCoda(MyWord, False)
                    'Print the word.
                       Print #2, MyWord;
                       If mnuTableau.Checked Then Print #3, MyWord;
                    'Print its length.
                        Print #2, Chr(9); NumberOfSegments(MyWord);
                        If mnuTableau.Checked Then Print #3, Chr(9); NumberOfSegments(MyWord);
                    'If the word is well-formed, then obtain the appropriate scores for it.  This is algorithm-specific.
                        Let MyErrorCheck = ErrorCheck(MyWord, False)
                        If MyErrorCheck = "AllCharactersOK" Then
                            Select Case Algorithm
                                Case "HayesWilson"
                                    'Syllabify the word:
                                        Let MyWord = Syllabify.Syllabified(MyWord)
                                    'Compute and print the maxent score:
                                        Let MyScoreString = Trim(Str(MaxentScore(MyWord)))
                                        Print #2, Chr(9); MyScoreString;
                                        If mnuTableau.Checked Then Print #3, Chr(9); MyScoreString;
                                    'The comment line has carriage returns; turn these into comma space for the spreadsheet.
                                        Print #2, Chr(9); Mid(Replace(mReportResultsString, gSeparator, ", "), 3);
                                        Print #2, Chr(9); Mid(Replace(mReportResultsString2, gSeparator, ", "), 3);
                                    'The violations in the tableau.
                                        If mnuTableau.Checked Then
                                            For ConstraintIndex = 1 To mNumberOfConstraints
                                                Print #3, Chr(9); Trim(Str(mTableau(ConstraintIndex)));
                                            Next ConstraintIndex
                                            Print #3,
                                        End If
                                Case "Vitevitch"
                                    'Compute and print both scores with their annotations.
                                        'The unigram score:
                                            Print #2, Chr(9); Trim(Str(VitevitchUnigramScore(MyWord)));
                                            'The comment line has carriage returns; turn these into comma space for the spreadsheet.
                                                Print #2, Chr(9); Mid(Replace(mReportResultsString, gSeparator, ", "), 3);
                                        'The bigram score:
                                            Print #2, Chr(9); Trim(Str(VitevitchBigramScore(MyWord)));
                                            'The comment line has carriage returns; turn these into comma space for the spreadsheet.
                                                Print #2, Chr(9); Mid(Replace(mReportResultsString, gSeparator, ", "), 3);
                                Case "Neighbors"
                                    'Compute and print the count of neighbors with list.
                                        Print #2, Chr(9); Trim(Str(CountNeighbors(MyWord)));
                                        'The comment line has carriage returns; turn these into comma space for the spreadsheet.
                                            Print #2, Chr(9); Replace(mReportResultsString, gSeparator, ", ");
                            End Select
                            'Print the user comment
                                Print #2, Chr(9); MyComment
                        Else
                            Print #2, Chr(9); "No score could be calculated. Uninterpretable symbol " + MyErrorCheck + "." + Chr(9); Chr(9); MyComment
                        End If
                Loop                'Go through the input file one line at a time.
            Close #2                'Close the main output file.
            Close #3                'Close the tableau file.
        Close #1
        
        'If the users wants a list of violating words, print it out.
            If mnuViolatorList.Checked Then
                Call PrintViolatorList
            End If
        
        'Final tasks:
            If Counter = 0 Then
                'Sometimes people make a null input file by mistake.
                    MsgBox "Error. Your input file: " + gDoubleLineBreak + App.Path + "/Input/" + txtInputFileName.Text + gDoubleLineBreak + "was empty, so I could not calculate anything.  Please fix the file and run the program again."
                    Close
                    End
            Else
                'Report completion.
                    Let lblAnnouncements.Caption = ""
                    Let lblPhonemeInventory.Caption = "Done.  You can find your output file in Output folder, daughter of the folder this program resides in."
            End If
        
        Exit Sub
        
ErrorPoint:
    Select Case Err.Number
        Case 76
            'You need to make the output folder.
                MkDir App.Path + "\Output"
                Resume
        Case 53
            'File not found.
                MsgBox ("Sorry, but I cannot find an input data file in the location you specified.  This location is:  " + _
                    gDoubleLineBreak + App.Path + "/Input/" + txtInputFileName.Text + gDoubleLineBreak + "  Please either move the file or change its specification in the input window.")
                Exit Sub
        End Select
        
End Sub

Function MakeUpper(MyString) As String
    'Capitalize the first letter of the input file name, in order to make a nicer output file name.
        Let MakeUpper = UCase(Left(MyString, 1)) + Mid(MyString, 2)
End Function

Public Function TrimCoda(MyWord As String, CheckingASingleWord As Boolean) As String
    'Warn user about Coda and trim it out.  No warning is issued for batch file mode.
        Dim i As Long
        Static TheWarningHasBeenGiven As Boolean
        
        If Replace(MyWord, "Coda", "") <> MyWord Then
            If TheWarningHasBeenGiven = False Then
                If CheckingASingleWord Then
                    MsgBox "I am ignoring the string " + Chr(34) + "Coda" + Chr(34) + " in the input form " + MyWord + ".  This program syllabifies automatically, using the editable onset and vowel lists provided."
                Else
                    MsgBox "I am ignoring the string " + Chr(34) + "Coda" + Chr(34) + " in the input form " + MyWord + ".  This program syllabifies automatically, using the editable onset and vowel lists provided. This message will not be repeated if I encounter similar cases."
                    Let TheWarningHasBeenGiven = True
                End If
            End If
            
            'Perform the fix.
                Let TrimCoda = MyWord
                For i = 1 To 10
                    Let TrimCoda = Replace(TrimCoda, "Coda", "")
                Next i
        Else
            Let TrimCoda = MyWord
        End If

End Function

Public Function ErrorCheck(MyInputWord As String, CheckingASingleWord As Boolean) As String

    'Make sure the input word is composed of legal phonemes.
    
        Dim MyWord As String, MyCharacter As String
        Dim PositionIndex As Long
        
        'Remember a previous decision to bull one's way through in spite of errors.
            Static ContinueAnyway As Boolean
        
        'Clean the word of extra spaces.
            Let MyWord = CleanMe(MyInputWord)
        'Look for bad symbols.
            Do
                Let PositionIndex = PositionIndex + 1
                Let MyCharacter = s.CustomChomp(MyWord, " ")
                If MyCharacter = "" Then Exit Do
                'Vet bad characters, giving the user the option of exiting.
                    If NumericalIndexOf(MyCharacter) = -1 Then
                        'For any outcome, the function will return the name of the bad character.
                            Let ErrorCheck = MyCharacter
                        'Select an outcome depending on mode of operation and user preference.
                            If CheckingASingleWord = True Then
                                'This is where you are just running a single word.
                                    MsgBox "I can't evaluate the word " + MyInputWord + " because it contains an unknown character, namely " + MyCharacter + "."
                                    Exit Function
                            ElseIf ContinueAnyway Then
                                'Don't bother the user with a choice they already made.
                                    Exit Function
                            Else
                                'User is evaluating a whole list, and has not yet entered an opinion.  So let them decide what to do.
                                    Select Case MsgBox("I can't evaluate the word " + MyInputWord + " because it contains an unknown character, namely " + MyCharacter + "." + gDoubleLineBreak + "Click Ok to continue anyway (without further interruption; symbol errors will be flagged in the output file)." + gDoubleLineBreak + "Click Cancel to quit the program.", vbOKCancel)
                                        Case vbOK
                                            Let ContinueAnyway = True
                                            Exit Function
                                        Case vbCancel
                                            Close
                                            End
                                    End Select
                            End If              'Single word or whole list?
                    End If                  'Found a bad character?
                'Go to next character.
                    Let MyWord = s.CustomResidue(MyWord, " ")
            Loop
        'We're ok; indicate this with the special string.
            Let ErrorCheck = "AllCharactersOK"
    
End Function


Function MaxentScore(MyInputWord As String)

    On Error GoTo ErrorPoint

    Dim MyWord As String, MySegment As String, EndingOfMySegment As String
    Dim MyNumericalIndex As Long
    Dim WordLength As Long
    Dim NthSegmentOfWord(30) As Long
    
    'The projections:  just vowels, just stressed vowels, just main-stressed vowels.
        Dim SyllableProjectionLength As Long
        Dim NthSegmentOfSyllableProjection(30) As Long
        Dim StressProjectionLength As Long
        Dim NthSegmentOfStressProjection(30) As Long
        Dim MainProjectionLength As Long
        Dim NthSegmentOfMainProjection(30) As Long
        Dim MyTier As String
    
    Dim PositionIndex As Long, ConstraintIndex As Long, SegmentIndex As Long
    
    'Initialize the strings that will report the violated constraints.
        Let mReportResultsString = ""
        Let mReportResultsString2 = ""
    'Initialize the score.
        Let mMaxentScore = 0
    'Clean the word of extra spaces.
        Let MyWord = CleanMe(MyInputWord)
    'Syllabify the word
        'Let MyWord = Syllabify.Syllabified(MyWord)
    'Add the word boundaries.
        Let MyWord = "# " + MyWord + " #"
        
    'Convert the word into a string of digits, on each tier.
        Do
            Let MySegment = s.CustomChomp(MyWord, " ")
            If MySegment = "" Then Exit Do
            Let MyNumericalIndex = NumericalIndexOf(MySegment)
            'First, the default tier.
                Let WordLength = WordLength + 1
                Let NthSegmentOfWord(WordLength) = MyNumericalIndex
            'Now, the prosodic tiers.
                Let EndingOfMySegment = Right(MySegment, 1)
                Select Case EndingOfMySegment
                    Case "#", "1"
                        Let MainProjectionLength = MainProjectionLength + 1
                        Let NthSegmentOfMainProjection(MainProjectionLength) = MyNumericalIndex
                End Select
                Select Case EndingOfMySegment
                    Case "#", "1", "2"
                        Let StressProjectionLength = StressProjectionLength + 1
                        Let NthSegmentOfStressProjection(StressProjectionLength) = MyNumericalIndex
                End Select
                Select Case EndingOfMySegment
                    Case "#", "1", "2", "0"
                        Let SyllableProjectionLength = SyllableProjectionLength + 1
                        Let NthSegmentOfSyllableProjection(SyllableProjectionLength) = MyNumericalIndex
                End Select
            Let MyWord = s.CustomResidue(MyWord, " ")
        Loop

        
    'Go through all the constraints.
        For ConstraintIndex = 1 To mNumberOfConstraints
            'Look up the tier on which the constraint applies.
                Let MyTier = LCase(mTiers(ConstraintIndex))
                Select Case MyTier
                    Case "default"
                        Select Case mMatrixCount(ConstraintIndex)
                            Case 4
                                'Evaluate tetragram violations.
                                    For PositionIndex = 1 To WordLength - 3
                                        If mNaturalClasses(NthSegmentOfWord(PositionIndex), mConstraints(1, ConstraintIndex)) = True Then
                                            If mNaturalClasses(NthSegmentOfWord(PositionIndex + 1), mConstraints(2, ConstraintIndex)) = True Then
                                                If mNaturalClasses(NthSegmentOfWord(PositionIndex + 2), mConstraints(3, ConstraintIndex)) = True Then
                                                    If mNaturalClasses(NthSegmentOfWord(PositionIndex + 3), mConstraints(4, ConstraintIndex)) = True Then Call UpdateMaxentScore(ConstraintIndex, MyTier, MyInputWord)
                                                End If
                                            End If
                                        End If
                                    Next PositionIndex
                            Case 3
                                'Evaluate trigram violations.
                                    For PositionIndex = 1 To WordLength - 2
                                        If mNaturalClasses(NthSegmentOfWord(PositionIndex), mConstraints(1, ConstraintIndex)) = True Then
                                            If mNaturalClasses(NthSegmentOfWord(PositionIndex + 1), mConstraints(2, ConstraintIndex)) = True Then
                                                If mNaturalClasses(NthSegmentOfWord(PositionIndex + 2), mConstraints(3, ConstraintIndex)) = True Then Call UpdateMaxentScore(ConstraintIndex, MyTier, MyInputWord)
                                            End If
                                        End If
                                    Next PositionIndex
                            Case 2
                                'Evaluate bigram violations.
                                    For PositionIndex = 1 To WordLength - 1
                                       If mNaturalClasses(NthSegmentOfWord(PositionIndex), mConstraints(1, ConstraintIndex)) = True Then
                                           If mNaturalClasses(NthSegmentOfWord(PositionIndex + 1), mConstraints(2, ConstraintIndex)) = True Then Call UpdateMaxentScore(ConstraintIndex, MyTier, MyInputWord)
                                       End If
                                    Next PositionIndex
                            Case 1
                                'Evaluate unigram violations.
                                    For PositionIndex = 1 To WordLength
                                        If mNaturalClasses(NthSegmentOfWord(PositionIndex), mConstraints(1, ConstraintIndex)) = True Then Call UpdateMaxentScore(ConstraintIndex, MyTier, MyInputWord)
                                    Next PositionIndex
                        End Select                          'How many matrices?
                    Case "main"
                        Select Case mMatrixCount(ConstraintIndex)
                            Case 4
                                'Evaluate tetragram violations.
                                    For PositionIndex = 1 To MainProjectionLength - 3
                                        If mNaturalClasses(NthSegmentOfMainProjection(PositionIndex), mConstraints(1, ConstraintIndex)) = True Then
                                            If mNaturalClasses(NthSegmentOfMainProjection(PositionIndex + 1), mConstraints(2, ConstraintIndex)) = True Then
                                                If mNaturalClasses(NthSegmentOfMainProjection(PositionIndex + 2), mConstraints(3, ConstraintIndex)) = True Then
                                                    If mNaturalClasses(NthSegmentOfMainProjection(PositionIndex + 3), mConstraints(4, ConstraintIndex)) = True Then Call UpdateMaxentScore(ConstraintIndex, MyTier, MyInputWord)
                                                End If
                                            End If
                                        End If
                                    Next PositionIndex
                            Case 3
                                'Evaluate trigram violations.
                                    For PositionIndex = 1 To MainProjectionLength - 2
                                        If mNaturalClasses(NthSegmentOfMainProjection(PositionIndex), mConstraints(1, ConstraintIndex)) = True Then
                                            If mNaturalClasses(NthSegmentOfMainProjection(PositionIndex + 1), mConstraints(2, ConstraintIndex)) = True Then
                                                If mNaturalClasses(NthSegmentOfMainProjection(PositionIndex + 2), mConstraints(3, ConstraintIndex)) = True Then Call UpdateMaxentScore(ConstraintIndex, MyTier, MyInputWord)
                                            End If
                                        End If
                                    Next PositionIndex
                            Case 2
                                'Evaluate bigram violations.
                                    For PositionIndex = 1 To MainProjectionLength - 1
                                       If mNaturalClasses(NthSegmentOfMainProjection(PositionIndex), mConstraints(1, ConstraintIndex)) = True Then
                                           If mNaturalClasses(NthSegmentOfMainProjection(PositionIndex + 1), mConstraints(2, ConstraintIndex)) = True Then Call UpdateMaxentScore(ConstraintIndex, MyTier, MyInputWord)
                                       End If
                                    Next PositionIndex
                            Case 1
                                'Evaluate unigram violations.
                                    For PositionIndex = 1 To MainProjectionLength
                                        If mNaturalClasses(NthSegmentOfMainProjection(PositionIndex), mConstraints(1, ConstraintIndex)) = True Then Call UpdateMaxentScore(ConstraintIndex, MyTier, MyInputWord)
                                    Next PositionIndex
                        End Select                          'How many matrices?
                    Case "stress"
                        Select Case mMatrixCount(ConstraintIndex)
                            Case 4
                                'Evaluate tetragram violations.
                                    For PositionIndex = 1 To StressProjectionLength - 3
                                        If mNaturalClasses(NthSegmentOfStressProjection(PositionIndex), mConstraints(1, ConstraintIndex)) = True Then
                                            If mNaturalClasses(NthSegmentOfStressProjection(PositionIndex + 1), mConstraints(2, ConstraintIndex)) = True Then
                                                If mNaturalClasses(NthSegmentOfStressProjection(PositionIndex + 2), mConstraints(3, ConstraintIndex)) = True Then
                                                    If mNaturalClasses(NthSegmentOfStressProjection(PositionIndex + 3), mConstraints(4, ConstraintIndex)) = True Then Call UpdateMaxentScore(ConstraintIndex, MyTier, MyInputWord)
                                                End If
                                            End If
                                        End If
                                    Next PositionIndex
                            Case 3
                                'Evaluate trigram violations.
                                    For PositionIndex = 1 To StressProjectionLength - 2
                                        If mNaturalClasses(NthSegmentOfStressProjection(PositionIndex), mConstraints(1, ConstraintIndex)) = True Then
                                            If mNaturalClasses(NthSegmentOfStressProjection(PositionIndex + 1), mConstraints(2, ConstraintIndex)) = True Then
                                                If mNaturalClasses(NthSegmentOfStressProjection(PositionIndex + 2), mConstraints(3, ConstraintIndex)) = True Then Call UpdateMaxentScore(ConstraintIndex, MyTier, MyInputWord)
                                            End If
                                        End If
                                    Next PositionIndex
                            Case 2
                                'Evaluate bigram violations.
                                    For PositionIndex = 1 To StressProjectionLength - 1
                                       If mNaturalClasses(NthSegmentOfStressProjection(PositionIndex), mConstraints(1, ConstraintIndex)) = True Then
                                           If mNaturalClasses(NthSegmentOfStressProjection(PositionIndex + 1), mConstraints(2, ConstraintIndex)) = True Then Call UpdateMaxentScore(ConstraintIndex, MyTier, MyInputWord)
                                       End If
                                    Next PositionIndex
                            Case 1
                                'Evaluate unigram violations.
                                    For PositionIndex = 1 To StressProjectionLength
                                        If mNaturalClasses(NthSegmentOfStressProjection(PositionIndex), mConstraints(1, ConstraintIndex)) = True Then Call UpdateMaxentScore(ConstraintIndex, MyTier, MyInputWord)
                                    Next PositionIndex
                                End Select                          'How many matrices?
                    Case "syllable"
                        Select Case mMatrixCount(ConstraintIndex)
                            Case 4
                                'Evaluate tetragram violations.
                                    For PositionIndex = 1 To SyllableProjectionLength - 3
                                        If mNaturalClasses(NthSegmentOfSyllableProjection(PositionIndex), mConstraints(1, ConstraintIndex)) = True Then
                                            If mNaturalClasses(NthSegmentOfSyllableProjection(PositionIndex + 1), mConstraints(2, ConstraintIndex)) = True Then
                                                If mNaturalClasses(NthSegmentOfSyllableProjection(PositionIndex + 2), mConstraints(3, ConstraintIndex)) = True Then
                                                    If mNaturalClasses(NthSegmentOfSyllableProjection(PositionIndex + 3), mConstraints(4, ConstraintIndex)) = True Then Call UpdateMaxentScore(ConstraintIndex, MyTier, MyInputWord)
                                                End If
                                            End If
                                        End If
                                    Next PositionIndex
                            Case 3
                                'Evaluate trigram violations.
                                    For PositionIndex = 1 To SyllableProjectionLength - 2
                                        If mNaturalClasses(NthSegmentOfSyllableProjection(PositionIndex), mConstraints(1, ConstraintIndex)) = True Then
                                            If mNaturalClasses(NthSegmentOfSyllableProjection(PositionIndex + 1), mConstraints(2, ConstraintIndex)) = True Then
                                                If mNaturalClasses(NthSegmentOfSyllableProjection(PositionIndex + 2), mConstraints(3, ConstraintIndex)) = True Then Call UpdateMaxentScore(ConstraintIndex, MyTier, MyInputWord)
                                            End If
                                        End If
                                    Next PositionIndex
                            Case 2
                                'Evaluate bigram violations.
                                    For PositionIndex = 1 To SyllableProjectionLength - 1
                                       If mNaturalClasses(NthSegmentOfSyllableProjection(PositionIndex), mConstraints(1, ConstraintIndex)) = True Then
                                           If mNaturalClasses(NthSegmentOfSyllableProjection(PositionIndex + 1), mConstraints(2, ConstraintIndex)) = True Then Call UpdateMaxentScore(ConstraintIndex, MyTier, MyInputWord)
                                       End If
                                    Next PositionIndex
                            Case 1
                                'Evaluate unigram violations.
                                    For PositionIndex = 1 To SyllableProjectionLength
                                        If mNaturalClasses(NthSegmentOfSyllableProjection(PositionIndex), mConstraints(1, ConstraintIndex)) = True Then Call UpdateMaxentScore(ConstraintIndex, MyTier, MyInputWord)
                                    Next PositionIndex
                        End Select                          'How many matrices?
                    Case Else
                        MsgBox "There is an error in the grammar.  The only tiers allowed are default, Main, Stress, and Syllable.  Program will exit."
                        Close
                        End
                End Select                                  'What tier does this constraint apply on?
        Next ConstraintIndex                                'Go through all constraints.
        
        'Report the aggregated score.
            Let MaxentScore = mMaxentScore
        
        Exit Function
        
ErrorPoint:
    MsgBox Str(mConstraints(1, ConstraintIndex))

End Function

Sub UpdateMaxentScore(MyConstraintIndex As Long, MyTier As String, MyWord As String)
    'Add the weight to the score.
        Let mMaxentScore = mMaxentScore + mWeights(MyConstraintIndex)
    
    'Add to the string that explains the grammar score of a form.
    'If the user included constraints with zero weight, there would be no point in printing them out here.
         If mWeights(MyConstraintIndex) > 0 Then
             'Formalized constraints with weights.
                Let mReportResultsString = mReportResultsString + gSeparator + mConstraintNames(MyConstraintIndex) + " (" + Trim(Str(mWeights(MyConstraintIndex))) + ") "
                If MyTier <> "default" Then
                    Let mReportResultsString = mReportResultsString + " (" + MyTier + " tier)"
                End If
             'Constraints as lists of segments.
                Let mReportResultsString2 = mReportResultsString2 + gSeparator + mConstraintsExpressedAsLists(MyConstraintIndex)
         End If
         
    'Update the tableau.
        If mnuTableau.Checked Then
            Let mTableau(MyConstraintIndex) = mTableau(MyConstraintIndex) + 1
        End If
        
    'Update the list of violating words.
        If mnuViolatorList.Checked Then
            Let mTotalViolations(MyConstraintIndex) = mTotalViolations(MyConstraintIndex) + 1
            If mListOfViolatingWords(MyConstraintIndex) = "" Then
                Let mListOfViolatingWords(MyConstraintIndex) = MyWord
            Else
                Let mListOfViolatingWords(MyConstraintIndex) = mListOfViolatingWords(MyConstraintIndex) + Chr(9) + MyWord
            End If
        End If
        
End Sub


Public Function CleanMe(MyWord As String) As String
    'Remove leading and trailing spaces, reduce space sequences to singles.
        Dim Buffer As String, i As Long
        
        Let Buffer = MyWord
        'Deal with spaces.
            For i = 1 To 10
                If Left(Buffer, 1) = " " Then Let Buffer = Mid(Buffer, 2)
                If Right(Buffer, 1) = " " Then Let Buffer = Left(Buffer, Len(Buffer) - 1)
                Let Buffer = Replace(Buffer, "  ", " ")
            Next i
        'Report result.
            Let CleanMe = Buffer
End Function

Function NumericalIndexOf(MyCharacter As String) As Long
    'Find the numerical index of a segment given as string.
        Dim SegmentIndex As Long
        For SegmentIndex = 1 To mNumberOfSegments
            If MyCharacter = gSegments(SegmentIndex) Then
                Let NumericalIndexOf = SegmentIndex
                Exit Function
            End If
        Next SegmentIndex
        'Failure:  report -1.
            Let NumericalIndexOf = -1
End Function

Public Function FindSegmentIndex(MySegment As String) As Long
    
    'Return the segment index if MySegment is a legal segment according to the list; else -1.
        Dim SegmentIndex As Long
        For SegmentIndex = 1 To mNumberOfSegments
            If MySegment = gSegments(SegmentIndex) Then
                Let FindSegmentIndex = SegmentIndex
                Exit Function
            End If
        Next SegmentIndex
        Let FindSegmentIndex = -1

End Function

Function NumberOfSegments(MyWord As String) As Long
    Dim i As Long
    Dim BufferNum As Long, BufferWord As String
    Let BufferWord = MyWord
    Let BufferNum = 1
    For i = 1 To 10
        Let BufferWord = Replace(BufferWord, "  ", " ")
    Next i
    For i = 1 To Len(BufferWord)
        If Mid(BufferWord, i, 1) = " " Then
            Let BufferNum = BufferNum + 1
        End If
    Next i
    Let NumberOfSegments = BufferNum
End Function

Sub PrintViolatorList()
    
    'Print out a list of forms violating each constraint.
        Dim ConstraintIndex As Long
        Open App.Path + "/Output/ListOfViolatingWordsFor" + MakeUpper(txtInputFileName.Text) For Output As #2
            'Print header.
                Print #2, "Constraint"; Chr(9); "Tier"; Chr(9); "Weight"; Chr(9); "Constraint as sequence of lists"; Chr(9); "# of violators"; Chr(9); "Violators"
            For ConstraintIndex = 1 To mNumberOfConstraints
                Print #2, mConstraintNames(ConstraintIndex);
                Print #2, Chr(9); mTiers(ConstraintIndex);
                Print #2, Chr(9); mWeights(ConstraintIndex);
                Print #2, Chr(9); mConstraintsExpressedAsLists(ConstraintIndex);
                Print #2, Chr(9); Trim(Str(mTotalViolations(ConstraintIndex)));
                'The list.  Take out the coda annotation for legibility.
                    Print #2, Chr(9); Replace(mListOfViolatingWords(ConstraintIndex), "Coda", "");
                Print #2,
            Next ConstraintIndex
            
        Close #2
        
End Sub


Private Sub cmdEnd_Click()
    Close
    End
End Sub



Private Sub mnuExpand_Click()
    'Expand the user interface to the maximum for reporting results.
        Let Me.Width = Screen.Width
        Let Me.Height = Screen.Height
        Let Me.Top = 0
        Let Me.Left = 0
        Let cmdEnd.Left = Screen.Width - cmdEnd.Width - 200
        Let cmdPostPhonemeLabels.Left = Screen.Width - cmdPostPhonemeLabels.Width - 200
        Let lblPhonemeInventory.Width = Screen.Width - cmdPostPhonemeLabels.Width
        Let lblPhonemeInventory.Height = Screen.Height - lblPhonemeInventory.Top
    
End Sub



Private Sub mnuNormalSize_Click()
    'Contract the user interface to normal size.
        Let Me.Width = 11025
        Let Me.Height = 8745
        Let Me.Top = 105
        Let Me.Left = 105
        Let cmdEnd.Left = 10080
        Let cmdPostPhonemeLabels.Left = 10080
        Let lblPhonemeInventory.Width = 9840
        Let lblPhonemeInventory.Height = 5760
End Sub

'==============================================================================================
'=========================================UTILITIES============================================
'==============================================================================================

Sub mnuHowToOpenAFile_Click()
    Dim dummy
    Let dummy = MsgBox("To rate the forms in an input file, put the file in the Input folder (daughter of the program folder), " + _
        "and type its name in the upper right text box of this program.  " + _
        "Then click on the button that says, Calculate scores for all words on this list. " + _
        gDoubleLineBreak + _
        "Your output file will be placed in the Output folder.", , "BLICK")
End Sub



Sub mnuVitevitchSingleForm_Click()
    'Remember the user's choice of input file.
        Call RememberInputFileName
    'Make sure that changes in the interface get recorded.
        DoEvents
    'Derive the result (in the Vitevitch module) and post it here.
        Let lblPhonemeInventory = VitevitchSingleForm(txtInputWord.Text)
End Sub

Sub mnuVitevichList_Click()
    'Using the Vitevitchian PPC, deal with an entire list of words.
        Call CalculateList("Vitevitch")
End Sub

Sub mnuCountNeighborsOneForm_Click()
    'Remember the user's choice of input file.
        Call RememberInputFileName
    'Make sure that changes in the interface get recorded.
        DoEvents
    'Call the code and report the result.
        Let lblPhonemeInventory = CountNeighborsOneForm(txtInputWord.Text)
End Sub

Sub mnuCountNeighborsList_Click()
    Call CalculateList("Neighbors")
End Sub


Private Sub mnuHelp_Click()
    Dim dummy
    Let dummy = MsgBox("There is no Help material in this program; however, there is a manual you can look at. You'll find it in the program folder, under the file name BLICKManual.pdf.", , "BLICK:  Phonotactic probability calculator")
End Sub


Private Sub mnuGrammarDefault_Click()
    Let mCurrentGrammar = "DefaultGrammar.txt"
    Let mnuGrammarCustomGrammar.Checked = False
    Let mnuGrammarDefault.Checked = True
    Let mnuGrammarHayesWhite.Checked = False
    Let mnuGrammarNoStress.Checked = False
    Call ReadTheNaturalClasses
    Call ReadTheGrammar
End Sub
Private Sub mnuGrammarNoStress_Click()
    Let mCurrentGrammar = "NoStressGrammar.txt"
    Let mnuGrammarCustomGrammar.Checked = False
    Let mnuGrammarDefault.Checked = False
    Let mnuGrammarHayesWhite.Checked = False
    Let mnuGrammarNoStress.Checked = True
    Call ReadTheNaturalClasses
    Call ReadTheGrammar
End Sub
Private Sub mnuGrammarHayesWhite_Click()
    Let mCurrentGrammar = "HayesWhiteGrammar.txt"
    Let mnuGrammarCustomGrammar.Checked = False
    Let mnuGrammarDefault.Checked = False
    Let mnuGrammarHayesWhite.Checked = True
    Let mnuGrammarNoStress.Checked = False
    Call ReadTheNaturalClasses
    Call ReadTheGrammar
End Sub
Private Sub mnuGrammarCustomGrammar_Click()
    Let mCurrentGrammar = "CustomGrammar.txt"
    Let mnuGrammarCustomGrammar.Checked = True
    Let mnuGrammarDefault.Checked = False
    Let mnuGrammarHayesWhite.Checked = False
    Let mnuGrammarNoStress.Checked = False
    Call ReadTheNaturalClasses
    Call ReadTheGrammar
End Sub

Private Sub mnuTableau_Click()
    If mnuTableau.Checked = False Then
        Let mnuTableau.Checked = True
    Else
        Let mnuTableau.Checked = False
    End If
End Sub

Private Sub mnuViolatorList_Click()
    If mnuViolatorList.Checked = False Then
        Let mnuViolatorList.Checked = True
    Else
        Let mnuViolatorList.Checked = False
    End If
End Sub

Private Sub mnuExit_Click()
    Call cmdEnd_Click
End Sub



